题解:P17564 「FAOI-R15」请注意你的空间常数

场切了,非常感动。

考虑固定一个 \(T\) 时的最小覆盖集。对于每个 \(I\in T\),把 \(I\) 在线段树上做分解,将所有分解出的节点求并即可覆盖 \(T\),但是这个显然不够优。尝试删去一些无用的节点,观察选中的某个线段树上的节点 \(p\),对 \(T\) 中所有不包含 \(p\) 的区间求并,若这个并完全覆盖了 \(p\),则 \(p\) 完全可以删去,因为 \(T\) 中不包含 \(p\) 的区间的分解节点的并显然可以覆盖 \(p\)。

据此可以猜测,一个节点 \(p\) 被保留当且仅当:

  • 存在 \(I\in T\),使得 \(p\) 是 \(I\) 分解出来的节点之一。
  • 对 \(T\) 中所有不包含 \(p\) 的区间求并,并集不能完全覆盖 \(p\)。

还需要证明这样是最优的。证明是赛后补的。

最优性证明

对于我们的方案中每个被选中的节点 \(p\),任取一个分解节点中包含 \(p\) 的区间 \(I_p\in T\),而 \(T\) 中所有不包含 \(p\) 的区间的并集不能完全覆盖 \(p\),再任取一个并集没有覆盖到的位置 \(x_p\)。

再来考虑任意一个合法方案,显然该方案为了覆盖 \(I_p\) 必然存在一个线段树节点 \(y_p\) 使得 \(x_p\in y_p\subseteq I_p\)。因为 \(p\) 是 \(I_p\) 的分解节点之一,所以会有 \(y_p\subseteq p\)。我们发现 \(y_p\) 互不相同:取我们的方案中两个不同的被选中的节点 \(p_1,p_2\),只用考虑 \(p_1\subseteq p_2\) 的情况,此时 \(I_{p_1}\) 不包含 \(p_2\),因此 \(x_{p_2}\notin I_{p_1}\),于是 \(x_{p_1}\neq x_{p_2}\)。

因此任意合法方案都不比我们的方案优。\(\Box\)

计算每个线段树节点 \(p\) 的贡献。设有 \(a_p\) 个区间的分解节点包含 \(p\),\(b_p\) 个区间与 \(p\) 相交且不包含 \(p\),这 \(b_p\) 个区间中 \(c_p\) 个子集可以覆盖 \(p\)。显然两类区间不交,因此 \(p\) 的贡献就是 \((2^{a_p}-1)(2^{b_p}-c_p)2^{m-a_p-b_p}\)。

考虑如何计算 \(c_p\)。问题转化为:给定 \(m\) 个区间,你可以从中选择若干个区间,求有多少种方案使得选出的区间可以覆盖 \([1,n]\)。将所有区间按左端点从小到大处理,直接 DP,令 \(f_i\) 表示从已处理的区间中选择若干个覆盖 \([1,n]\) 的方案数。加入一个区间 \([s,t]\) 时,对于 \(s-1\leq i<t\),状态 \(f_i\) 可以贡献到 \(f_t\);对于 \(i\geq t\),区间 \([s,t]\) 是可选的。由此得到转移:

\[\begin{align*} f_i&\gets 2f_i&(t\leq i\leq n)\\ f_t&\gets f_t+\sum_{i=s-1}^{t-1}f_i\\ \end{align*} \]

用线段树维护区间乘、区间和、单点加即可。时间复杂度为 \(\mathcal{O}(m\log{n})\)。

\(a_p,b_p\) 容易在线段树递归过程中计算,递归过程中维护若干区间,若维护的某个区间完全包含当前节点就停止下传即可。时间复杂度为 \(\mathcal{O}(n\log{n}+m\log^2{n})\)。

主要代码
int n, m;
mint ans, pw2[MAXM];

struct Range {
	int l, r;
};

vector<Range> R;

struct SegTree {
#define ls(p) (p << 1)
#define rs(p) (p << 1 | 1)
	mint sum[MAXN << 2], tg[MAXN << 2];

	void pushUp(int p) {
		sum[p] = sum[ls(p)] + sum[rs(p)];
	}

	void apply(int p, mint v) {
		sum[p] *= v;
		tg[p] *= v;
	}

	void pushDown(int p) {
		if (tg[p].val() == 1) return;
		apply(ls(p), tg[p]);
		apply(rs(p), tg[p]);
		tg[p] = 1;
	}

	void build(int p, int l, int r) {
		tg[p] = 1;
		if (l == r) {
			sum[p] = !l;
			return;
		}
		int mid = l + r >> 1;
		build(ls(p), l, mid);
		build(rs(p), mid + 1, r);
		pushUp(p);
	}

	void add(int p, int l, int r, int x, mint v) {
		if (l == r) {
			sum[p] += v;
			return;
		}
		pushDown(p);
		int mid = l + r >> 1;
		if (x <= mid) add(ls(p), l, mid, x, v);
		else add(rs(p), mid + 1, r, x, v);
		pushUp(p);
	}

	void mul(int p, int l, int r, int x, int y, mint v) {
		if (x <= l && y >= r) {
			apply(p, v);
			return;
		}
		pushDown(p);
		int mid = l + r >> 1;
		if (x <= mid) mul(ls(p), l, mid, x, y, v);
		if (y > mid) mul(rs(p), mid + 1, r, x, y, v);
		pushUp(p);
	}

	mint query(int p, int l, int r, int x, int y) {
		if (x <= l && y >= r) return sum[p];
		pushDown(p);
		int mid = l + r >> 1;
		mint res = 0;
		if (x <= mid) res = query(ls(p), l, mid, x, y);
		if (y > mid) res += query(rs(p), mid + 1, r, x, y);
		return res;
	}

	mint solve(int l, int r, const vector<Range> &R) {
		int len = r - l + 1;
		build(1, 0, len);
		for (auto [s, t] : R) {
			mint sum = query(1, 0, len, s - l, t - l);
			mul(1, 0, len, t - l + 1, len, 2);
			add(1, 0, len, t - l + 1, sum);
		}
		return query(1, 0, len, len, len);
	}
#undef ls
#undef rs
} sgt;

void solve(int l, int r, int cnt, const vector<Range> &R) {
	if (cnt) {
		mint c = sgt.solve(l, r, R);
		ans += (pw2[cnt] - 1) * (pw2[R.size()] - c) * pw2[m - cnt - R.size()];
	}
	if (R.empty()) return;

	int mid = l + r >> 1;
	int cl = 0, cr = 0;
	vector<Range> vecL, vecR;
	for (auto [s, t] : R) {
		if (s <= mid) {
			int nt = min(t, mid);
			if (s == l && nt == mid) ++cl;
			else vecL.push_back({s, nt});
		}
		if (t > mid) {
			int ns = max(s, mid + 1);
			if (ns == mid + 1 && t == r) ++cr;
			else vecR.push_back({ns, t});
		}
	}

	solve(l, mid, cl, vecL);
	solve(mid + 1, r, cr, vecR);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	cin >> n >> m;
	int cr = 0;
	for (int i = 1; i <= m; ++i) {
		int l, r;
		cin >> l >> r;
		if (l == 1 && r == n) ++cr;
		else R.push_back({l, r});
	}

	pw2[0] = 1;
	for (int i = 1; i <= m; ++i) pw2[i] = pw2[i - 1] * 2;

	sort(R.begin(), R.end(), [&](const Range &lhs, const Range &rhs) {
		return lhs.l < rhs.l;
	});
	solve(1, n, cr, R);
	cout << ans;
	return 0;
}
posted @ 2026-10-02 22:51  P2441M  阅读(16)  评论(0)    收藏  举报